var jsdomify = require('jsdomify');
jsdomify.create();

React = require('react/addons');
expect = require('unexpected');

expect = require('unexpected').clone();
expect.installPlugin(require('../lib/unexpected-react'));

var SomeComponent = require('../components/SomeComponent.jsx');

var ReactTestUtils = React.addons.TestUtils;

describe('Assertions:', function () {

  var data = {
    value: 234,
    label: 'label'
  };

  it('should have requested properties', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'to have props', ['value', 'label'])
  });

  it('should have requested properties with correct values', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'to have props', {value: 234, label: 'label'})
  });

  it('should have requested properties with correct values (not exahustive)', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'to have props', {label: 'label'})
  });

  it('should not have requested properties', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'not to have props', ['some', 'other'])
  });

  it('should have requested state', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'to have state', ['status'])
  });

  it('should not have requested state', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'not to have state', ['bananas'])
  });

  it('should have requested state with correct values', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'to have state', {status: 'working'})
  });

  it('should have 3 children', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label}>
        <span>something</span>
        <span>something</span>
        <span>something</span>
      </SomeComponent>
    );

    expect(component, 'to have children', 3)
  });

  it('should have 1 children', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label}>
        <span>something</span>
      </SomeComponent>
    );

    expect(component, 'to have children', 1)
  });

  it('should not have children', function () {
    var component = ReactTestUtils.renderIntoDocument(
      <SomeComponent value={data.value} label={data.label} />
    );

    expect(component, 'not to have children')
  });

});
